
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class PanelTraductor extends JPanel implements
        ActionListener {

    private Traductor traductor;

    private JLabel etiqueta;
    private JTextField campo;
    private JButton boton;
    private JButton botonCambioIdioma;
    private JLabel etiquetaIdioma;

    public PanelTraductor(Traductor traductor) {

        this.traductor = traductor;

        etiqueta = new JLabel("Pulsa el boton para traducir");
        campo = new JTextField(20);
        boton = new JButton("Traducir");
        botonCambioIdioma = new JButton(
                "Invierte sentido traduccin");
        etiquetaIdioma = new JLabel();

        this.muestraSentidoTraduccion();

        boton.addActionListener(this);
        campo.addActionListener(this);
        botonCambioIdioma.addActionListener(this);

        GestorEventosRollOver gestor = new GestorEventosRollOver();

        etiqueta.addMouseListener(gestor);
        campo.addMouseListener(gestor);
        boton.addMouseListener(gestor);
        botonCambioIdioma.addMouseListener(gestor);
        etiquetaIdioma.addMouseListener(gestor);

        this.add(campo);
        this.add(boton);
        this.add(etiqueta);
        this.add(botonCambioIdioma);
        this.add(etiquetaIdioma);

    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == botonCambioIdioma) {
            traductor.invierteIdioma();
            this.muestraSentidoTraduccion();
        } else {
            etiqueta.setText(traductor.traducePalabra(campo
                    .getText()));
        }
    }

    private void muestraSentidoTraduccion() {
        etiquetaIdioma.setText(Traductor
                .getCadenaIdioma(traductor.getIdiomaOrigen())
                + " - "
                + Traductor.getCadenaIdioma(traductor
                        .getIdiomaDestino()));
    }

}