
import java.awt.Dimension;

import javax.swing.BorderFactory;
import javax.swing.JPanel;

public class PanelSeleccionIdioma extends JPanel {

    public static final int IDIOMA_ORIGEN = 0;
    public static final int IDIOMA_DESTINO = 1;

    private Traductor traductor;

    private int tipoIdioma;
    private PanelTraductor panelTraductor;
    private PanelRadioButtons panelRadioButtons;

    public PanelSeleccionIdioma(int tipoIdioma,
            Traductor traductor, PanelTraductor panelTraductor) {

        this.panelTraductor = panelTraductor;
        this.tipoIdioma = tipoIdioma;
        this.traductor = traductor;

        String cadenaTipo;

        if (tipoIdioma == IDIOMA_ORIGEN) {
            cadenaTipo = " Idioma Origen ";
        } else {
            cadenaTipo = " Idioma Destino ";
        }

        this.setBorder(BorderFactory
                .createTitledBorder(cadenaTipo));
        this.setMinimumSize(new Dimension(110, 110));
        this.setPreferredSize(new Dimension(110, 110));

        panelRadioButtons = new PanelRadioButtons(Traductor.NUM_IDIOMAS, 1);
        
        this.add(panelRadioButtons);
        
        for (int i = 0; i < Traductor.NUM_IDIOMAS; i++) {

            boolean seleccionado = (tipoIdioma == IDIOMA_ORIGEN && i == traductor
                    .getIdiomaOrigen())
                    || (tipoIdioma == IDIOMA_DESTINO && i == traductor
                            .getIdiomaDestino());

            panelRadioButtons.addRadioButton(Traductor.getCadenaIdioma(i),
                    seleccionado);

            panelRadioButtons.addRadioListener(new RadioListener() {
                public void radioSelectionChanged(RadioEvent e) {
                    botonRadioSeleccioado(e.getNumOpcion());	
                }
            });
        }
    }

    public void botonRadioSeleccioado(int numBoton) {

        if (this.tipoIdioma == IDIOMA_ORIGEN) {
            traductor.setIdiomaOrigen(numBoton);
        } else if (this.tipoIdioma == IDIOMA_DESTINO) {
            traductor.setIdiomaDestino(numBoton);
        } else {
            throw new Error();
        }

        this.panelTraductor.muestraIdiomas();

    }
}