
import java.awt.GridLayout;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

public class PanelRadioButtons extends JPanel {

    private ButtonGroup grupo = new ButtonGroup();
    private int numBotones = 0;

    public PanelRadioButtons(int numFilas, int numColumnas) {
        this.setLayout(new GridLayout(numFilas, numColumnas));
    }

    public void addRadioButton(String texto, boolean seleccionado) {

        JRadioButton boton = new JRadioButton(texto);
        grupo.add(boton);
        boton.setSelected(seleccionado);
        this.add(boton);

        final int numBoton = numBotones;

        boton.addItemListener(new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                if (e.getStateChange() == ItemEvent.SELECTED) {
                    botonRadioSeleccionado(numBoton);
                }
            }
        });

        this.numBotones++;
    }

    protected void botonRadioSeleccionado(int numBoton) {
        this.fireRadioSelectionChanged(new RadioEvent(this,
                numBoton));
    }

    public void addRadioListener(RadioListener l) {
        listenerList.add(RadioListener.class, l);
    }

    public void removeRadioListener(RadioListener l) {
        listenerList.remove(RadioListener.class, l);
    }

    protected void fireRadioSelectionChanged(RadioEvent event) {

        Object[] listeners = listenerList.getListenerList();

        //Mtodo invocado cuando se quiere generar un evento
        for (int i = listeners.length - 2; i >= 0; i -= 2) {
            if (listeners[i] == RadioListener.class) {
                ((RadioListener) listeners[i + 1])
                        .radioSelectionChanged(event);
            }
        }
    }

}

