
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.event.ChangeListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

class PanelTextos extends JPanel {

    private Traductor traductor;

    private JLabel etiquetaOrigen;
    private JLabel etiquetaDestino;
    private JTextArea areaOrigen;
    private JTextArea areaDestino;

    public PanelTextos(Traductor traductor) {

        this.traductor = traductor;
        this.traductor.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent e) {
                muestraIdiomas();
            }
        });

        this.etiquetaOrigen = new JLabel();
        this.etiquetaDestino = new JLabel();
        this.muestraIdiomas();

        this.areaOrigen = new JTextArea("Escriba el texto aqui", 2, 20);

        this.areaOrigen.getDocument().addDocumentListener(
                new DocumentListener() {

                    public void insertUpdate(DocumentEvent e) {
                        traducir();
                    }

                    public void removeUpdate(DocumentEvent e) {
                        traducir();
                    }

                    public void changedUpdate(DocumentEvent e) {
                        traducir();
                    }
                });

        this.areaDestino = new JTextArea("Aqui aparecer la traduccion", 2, 20);
        this.areaDestino.setEditable(false);

        this.setBorder(BorderFactory.createTitledBorder(" Traduccion "));

        JScrollPane spAreaOrigen = new JScrollPane(areaOrigen);
        JScrollPane spAreaDestino = new JScrollPane(areaDestino);

        this.setLayout(new GridBagLayout());

        GridBagConstraints config1 = new GridBagConstraints();
        config1.insets = new Insets(3, 3, 3, 3);
        config1.anchor = GridBagConstraints.WEST;
        this.add(etiquetaOrigen, config1);

        GridBagConstraints config2 = new GridBagConstraints();
        config2.insets = new Insets(3, 3, 3, 3);
        config2.anchor = GridBagConstraints.WEST;
        config2.gridy = 2;
        this.add(etiquetaDestino, config2);

        GridBagConstraints config4 = new GridBagConstraints();
        config4.insets = new Insets(3, 3, 3, 3);
        config4.weighty = 1.0;
        config4.weightx = 1.0;
        config4.fill = GridBagConstraints.BOTH;
        config4.gridy = 1;
        this.add(spAreaOrigen, config4);

        GridBagConstraints config5 = new GridBagConstraints();
        config5.insets = new Insets(3, 3, 3, 3);
        config5.weighty = 1.0;
        config5.weightx = 1.0;
        config5.fill = GridBagConstraints.BOTH;
        config5.gridy = 3;
        this.add(spAreaDestino, config5);
    }

    public void traducir() {
        areaDestino.setText(traductor.traduceTexto(areaOrigen.getText()));
    }

    public void muestraIdiomas() {
        this.etiquetaOrigen.setText(" Idioma "
                + Traductor.getCadenaIdioma(traductor.getIdiomaOrigen()));
        this.etiquetaDestino.setText(" Idioma "
                + Traductor.getCadenaIdioma(traductor.getIdiomaDestino()));
    }
}