
import javax.swing.JFrame;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class VentanaTraductor extends JFrame {

    private Traductor traductor;

    public VentanaTraductor(Traductor traductor) {

        this.traductor = traductor;
        this.setContentPane(new PanelTraductor(traductor));

        traductor.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent e) {
                muestraIdiomas();
            }
        });

        this.muestraIdiomas();
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.pack();
        this.setVisible(true);
    }

    protected void muestraIdiomas() {
        this.setTitle("Traductor de "
                + Traductor.getCadenaIdioma(traductor
                        .getIdiomaOrigen())
                + " a "
                + Traductor.getCadenaIdioma(traductor
                        .getIdiomaDestino()));
    }
}

